'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.path = undefined;

var _pathTemplateToParameterNames = require('./_/path-template-to-parameter-names');

var _toParameterPattern = require('./_/to-parameter-pattern');

var path = function path(template, patterns) {
    var parameterNames = (0, _pathTemplateToParameterNames.pathTempalteToParameterNames)(template);
    return function (params) {
        if (parameterNames.some(function (name) {
            return typeof params[name] !== 'string';
        })) {
            return null;
        }
        var parameterPattern = (0, _toParameterPattern.toParameterPattern)(template, patterns);
        if (parameterPattern.some(function (_ref) {
            var name = _ref.name,
                pattern = _ref.pattern;

            return pattern !== null && params[name].match(pattern) === null;
        })) {
            return null;
        }
        return parameterNames.reduce(function (a, name) {
            return a.split('{' + name + '}').join(encodeURIComponent(params[name]));
        }, template);
    };
};
exports.path = path;